import rison from 'rison';

// parses url
let getQueryVariable = function (variable, href) {
  let array = href.split('?');
  if (array.length < 2) {
    console.warn('Query variable %s not found', variable);
    return;
  }
  let query = array[1];
  let vars = query.split('&');
  for (let i = 0; i < vars.length; i++) {
    let pair = vars[i].split('=');
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
  console.warn('Query variable %s not found', variable);
};

let replaceParam = function (href, key, val) {
  let array = href.split('?');
  if (array.length < 2) {
    console.warn('Query variable %s not found', key);
    return href;
  }
  let query = array[1];
  let vars = query.split('&');
  for (let i = 0; i < vars.length; i++) {
    let pair = vars[i].split('=');
    if (decodeURIComponent(pair[0]) === key) {
      vars[i] = key + '=' + val;
    }
  }
  return array[0] + '?' + vars.join('&');
};

let getGlobalState = function (params) {
  return rison.decode(decodeURIComponent(getQueryVariable('_g', params.href)));
};

let getAppState = function (params) {
  return rison.decode(decodeURIComponent(getQueryVariable('_a', params.href)));
};

export default {
  getQueryVariable: getQueryVariable,
  replaceParam: replaceParam,
  getGlobalState: getGlobalState,
  getAppState: getAppState
};
